package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRTrainingRecord;
import cn.ibizlab.humanresource.core.humanresource.filter.HRTrainingRecordSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRTrainingRecord] 服务对象接口
 */
public interface IHRTrainingRecordService extends IService<HRTrainingRecord>{

    boolean create(HRTrainingRecord et) ;
    void createBatch(List<HRTrainingRecord> list) ;
    boolean update(HRTrainingRecord et) ;
    void updateBatch(List<HRTrainingRecord> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRTrainingRecord get(String key) ;
    HRTrainingRecord getDraft(HRTrainingRecord et) ;
    boolean checkKey(HRTrainingRecord et) ;
    boolean save(HRTrainingRecord et) ;
    void saveBatch(List<HRTrainingRecord> list) ;
    Page<HRTrainingRecord> searchDefault(HRTrainingRecordSearchContext context) ;
    List<HRTrainingRecord> selectByHremployeeid(String employeeid) ;
    void removeByHremployeeid(String employeeid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRTrainingRecord> getHrtrainingrecordByIds(List<String> ids) ;
    List<HRTrainingRecord> getHrtrainingrecordByEntities(List<HRTrainingRecord> entities) ;
}


